# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FormLayoutNestedFields(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'display': 'str',
        'styles': 'str',
        'state': 'FormLayoutState',
        'size': 'int',
        'submit': 'bool',
        'signpost_position': 'str'
    }

    attribute_map = {
        'id': 'id',
        'display': 'display',
        'styles': 'styles',
        'state': 'state',
        'size': 'size',
        'submit': 'submit',
        'signpost_position': 'signpostPosition'
    }

    def __init__(self, id=None, display=None, styles=None, state=None, size=None, submit=None, signpost_position=None):  # noqa: E501
        """FormLayoutNestedFields - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._display = None
        self._styles = None
        self._state = None
        self._size = None
        self._submit = None
        self._signpost_position = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if display is not None:
            self.display = display
        if styles is not None:
            self.styles = styles
        if state is not None:
            self.state = state
        if size is not None:
            self.size = size
        if submit is not None:
            self.submit = submit
        if signpost_position is not None:
            self.signpost_position = signpost_position

    @property
    def id(self):
        """Gets the id of this FormLayoutNestedFields.  # noqa: E501


        :return: The id of this FormLayoutNestedFields.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FormLayoutNestedFields.


        :param id: The id of this FormLayoutNestedFields.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def display(self):
        """Gets the display of this FormLayoutNestedFields.  # noqa: E501


        :return: The display of this FormLayoutNestedFields.  # noqa: E501
        :rtype: str
        """
        return self._display

    @display.setter
    def display(self, display):
        """Sets the display of this FormLayoutNestedFields.


        :param display: The display of this FormLayoutNestedFields.  # noqa: E501
        :type: str
        """
        allowed_values = ["text", "textArea", "textField", "passwordField", "decimalField", "integerField", "dropDown", "checkbox", "radio", "datagrid", "objectField", "image", "multiSelect", "dualList", "valuePicker", "multiValuePicker", "valuePickerTree", "combobox", "dateTime", "link", "fileUpload", "array"]  # noqa: E501
        if display not in allowed_values:
            raise ValueError(
                "Invalid value for `display` ({0}), must be one of {1}"  # noqa: E501
                .format(display, allowed_values)
            )

        self._display = display

    @property
    def styles(self):
        """Gets the styles of this FormLayoutNestedFields.  # noqa: E501


        :return: The styles of this FormLayoutNestedFields.  # noqa: E501
        :rtype: str
        """
        return self._styles

    @styles.setter
    def styles(self, styles):
        """Sets the styles of this FormLayoutNestedFields.


        :param styles: The styles of this FormLayoutNestedFields.  # noqa: E501
        :type: str
        """

        self._styles = styles

    @property
    def state(self):
        """Gets the state of this FormLayoutNestedFields.  # noqa: E501


        :return: The state of this FormLayoutNestedFields.  # noqa: E501
        :rtype: FormLayoutState
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this FormLayoutNestedFields.


        :param state: The state of this FormLayoutNestedFields.  # noqa: E501
        :type: FormLayoutState
        """

        self._state = state

    @property
    def size(self):
        """Gets the size of this FormLayoutNestedFields.  # noqa: E501


        :return: The size of this FormLayoutNestedFields.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this FormLayoutNestedFields.


        :param size: The size of this FormLayoutNestedFields.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def submit(self):
        """Gets the submit of this FormLayoutNestedFields.  # noqa: E501


        :return: The submit of this FormLayoutNestedFields.  # noqa: E501
        :rtype: bool
        """
        return self._submit

    @submit.setter
    def submit(self, submit):
        """Sets the submit of this FormLayoutNestedFields.


        :param submit: The submit of this FormLayoutNestedFields.  # noqa: E501
        :type: bool
        """

        self._submit = submit

    @property
    def signpost_position(self):
        """Gets the signpost_position of this FormLayoutNestedFields.  # noqa: E501


        :return: The signpost_position of this FormLayoutNestedFields.  # noqa: E501
        :rtype: str
        """
        return self._signpost_position

    @signpost_position.setter
    def signpost_position(self, signpost_position):
        """Sets the signpost_position of this FormLayoutNestedFields.


        :param signpost_position: The signpost_position of this FormLayoutNestedFields.  # noqa: E501
        :type: str
        """

        self._signpost_position = signpost_position

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FormLayoutNestedFields, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FormLayoutNestedFields):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
